Loading...
Searching...
No Matches
casacore::MSConcat Class Reference
ms package (libcasa_ms) » MSOper_module

More...

`#include <MSConcat.h>`

## Public Member Functions

| MSConcat (MeasurementSet &ms)
void | virtualconcat (MeasurementSet &otherMS, const Bool checkShapeAndCateg=True, const String &obsidAndProcAndScanTableName="")
void | concatenate (const MeasurementSet &otherMS, const uInt handling=0, const String &destMSName="")
void | setTolerance (Quantum< Double > &freqTol, Quantum< Double > &dirTol)
void | setWeightScale (const Float weightScale)
void | setRespectForFieldName (const Bool respectFieldName)
Public Member Functions inherited from casacore::MSColumns
| MSColumns (const MeasurementSet &ms)
| Create a columns object that accesses the data in the specified MS.
| ~MSColumns ()
| The destructor does nothing special.
MSAntennaColumns & | antenna ()
| Access to required subtables.
MSDataDescColumns & | dataDescription ()
MSFeedColumns & | feed ()
MSFieldColumns & | field ()
MSFlagCmdColumns & | flagCmd ()
MSHistoryColumns & | history ()
MSObservationColumns & | observation ()
MSPointingColumns & | pointing ()
MSPolarizationColumns & | polarization ()
MSProcessorColumns & | processor ()
MSSpWindowColumns & | spectralWindow ()
MSStateColumns & | state ()
MSDopplerColumns & | doppler ()
| Access to optional subtables.
MSFreqOffsetColumns & | freqOffset ()
MSSourceColumns & | source ()
MSSysCalColumns & | sysCal ()
MSWeatherColumns & | weather ()
const MSAntennaColumns & | antenna () const
| Access to required subtables.
const MSDataDescColumns & | dataDescription () const
const MSFeedColumns & | feed () const
const MSFieldColumns & | field () const
const MSFlagCmdColumns & | flagCmd () const
const MSHistoryColumns & | history () const
const MSObservationColumns & | observation () const
const MSPointingColumns & | pointing () const
const MSPolarizationColumns & | polarization () const
const MSProcessorColumns & | processor () const
const MSSpWindowColumns & | spectralWindow () const
const MSStateColumns & | state () const
const MSDopplerColumns & | doppler () const
| Access to optional subtables.
const MSFreqOffsetColumns & | freqOffset () const
const MSSourceColumns & | source () const
const MSSysCalColumns & | sysCal () const
const MSWeatherColumns & | weather () const
void | setEpochRef (MEpoch::Types ref, Bool tableMustBeEmpty=True)
| set the EPOCH reference type in all EPOCH columns in the MS.
void | setDirectionRef (MDirection::Types ref)
| set the DIRECTION reference type for FIELD, POINTING and SOURCE tables (except for antenna frame directions).
Public Member Functions inherited from casacore::MSMainColumns
| MSMainColumns (const MeasurementSet &ms)
| Create a columns object that accesses the data in the specified Table.
| ~MSMainColumns ()
| The desctructor does nothing special.
ScalarColumn< Int > & | antenna1 ()
| Access to required columns.
ScalarColumn< Int > & | antenna2 ()
ScalarColumn< Int > & | arrayId ()
ScalarColumn< Int > & | dataDescId ()
ScalarColumn< Double > & | exposure ()
ScalarQuantColumn< Double > & | exposureQuant ()
ScalarColumn< Int > & | feed1 ()
ScalarColumn< Int > & | feed2 ()
ScalarColumn< Int > & | fieldId ()
ArrayColumn< Bool > & | flag ()
ArrayColumn< Bool > & | flagCategory ()
ScalarColumn< Bool > & | flagRow ()
ScalarColumn< Double > & | interval ()
ScalarQuantColumn< Double > & | intervalQuant ()
ScalarColumn< Int > & | observationId ()
ScalarColumn< Int > & | processorId ()
ScalarColumn< Int > & | scanNumber ()
ArrayColumn< Float > & | sigma ()
ScalarColumn< Int > & | stateId ()
ScalarColumn< Double > & | time ()
ScalarQuantColumn< Double > & | timeQuant ()
ScalarMeasColumn< MEpoch > & | timeMeas ()
ScalarColumn< Double > & | timeCentroid ()
ScalarQuantColumn< Double > & | timeCentroidQuant ()
ScalarMeasColumn< MEpoch > & | timeCentroidMeas ()
ArrayColumn< Double > & | uvw ()
ArrayQuantColumn< Double > & | uvwQuant ()
ScalarMeasColumn< Muvw > & | uvwMeas ()
ArrayColumn< Float > & | weight ()
ScalarColumn< Int > & | antenna3 ()
| Access to optional columns.
ScalarColumn< Bool > & | baselineRef ()
ArrayColumn< Complex > & | correctedData ()
ArrayColumn< Complex > & | data ()
ScalarColumn< Int > & | feed3 ()
ArrayColumn< Float > & | floatData ()
ArrayColumn< Float > & | imagingWeight ()
ArrayColumn< Complex > & | lagData ()
ArrayColumn< Complex > & | modelData ()
ScalarColumn< Int > & | phaseId ()
ScalarColumn< Int > & | pulsarBin ()
ScalarColumn< Int > & | pulsarGateId ()
ArrayColumn< Float > & | sigmaSpectrum ()
ScalarColumn< Double > & | timeExtraPrec ()
ScalarQuantColumn< Double > & | timeExtraPrecQuant ()
ArrayColumn< Double > & | uvw2 ()
ScalarMeasColumn< Muvw > & | uvw2Meas ()
ArrayQuantColumn< Double > & | uvw2Quant ()
ArrayColumn< Complex > & | videoPoint ()
ArrayColumn< Float > & | weightSpectrum ()
ArrayColumn< Float > & | weightSpectrumCorrected ()
const ScalarColumn< Int > & | antenna1 () const
| Const access to required columns.
const ScalarColumn< Int > & | antenna2 () const
const ScalarColumn< Int > & | arrayId () const
const ScalarColumn< Int > & | dataDescId () const
const ScalarColumn< Double > & | exposure () const
const ScalarQuantColumn< Double > & | exposureQuant () const
const ScalarColumn< Int > & | feed1 () const
const ScalarColumn< Int > & | feed2 () const
const ScalarColumn< Int > & | fieldId () const
const ArrayColumn< Bool > & | flag () const
const ArrayColumn< Bool > & | flagCategory () const
const ScalarColumn< Bool > & | flagRow () const
const ScalarColumn< Double > & | interval () const
const ScalarQuantColumn< Double > & | intervalQuant () const
const ScalarColumn< Int > & | observationId () const
const ScalarColumn< Int > & | processorId () const
const ScalarColumn< Int > & | scanNumber () const
const ArrayColumn< Float > & | sigma () const
const ScalarColumn< Int > & | stateId () const
const ScalarColumn< Double > & | time () const
const ScalarQuantColumn< Double > & | timeQuant () const
const ScalarMeasColumn< MEpoch > & | timeMeas () const
const ScalarColumn< Double > & | timeCentroid () const
const ScalarQuantColumn< Double > & | timeCentroidQuant () const
const ScalarMeasColumn< MEpoch > & | timeCentroidMeas () const
const ArrayColumn< Double > & | uvw () const
const ArrayQuantColumn< Double > & | uvwQuant () const
const ScalarMeasColumn< Muvw > & | uvwMeas () const
const ArrayColumn< Float > & | weight () const
const ScalarColumn< Int > & | antenna3 () const
| Access to optional columns.
const ScalarColumn< Bool > & | baselineRef () const
const ArrayColumn< Complex > & | correctedData () const
const ArrayColumn< Complex > & | data () const
const ScalarColumn< Int > & | feed3 () const
const ArrayColumn< Float > & | floatData () const
const ArrayColumn< Float > & | imagingWeight () const
const ArrayColumn< Complex > & | lagData () const
const ArrayColumn< Complex > & | modelData () const
const ScalarColumn< Int > & | phaseId () const
const ScalarColumn< Int > & | pulsarBin () const
const ScalarColumn< Int > & | pulsarGateId () const
const ArrayColumn< Float > & | sigmaSpectrum () const
const ScalarColumn< Double > & | timeExtraPrec () const
const ScalarQuantColumn< Double > & | timeExtraPrecQuant () const
const ArrayColumn< Double > & | uvw2 () const
const ScalarMeasColumn< Muvw > & | uvw2Meas () const
const ArrayQuantColumn< Double > & | uvw2Quant () const
const ArrayColumn< Complex > & | videoPoint () const
const ArrayColumn< Float > & | weightSpectrum () const
const ArrayColumn< Float > & | weightSpectrumCorrected () const
rownr_t | nrow () const
| Convenience function that returns the number of rows in any of the columns.
Vector< String > | flagCategories () const
| Returns the category labels for the FLAG_CATEGORY column.
void | setEpochRef (MEpoch::Types ref, Bool tableMustBeEmpty=True)
| set the epoch type for the TIME and TIME_CENTROID columns.
void | setUVWRef (Muvw::Types ref)
| set the UVW reference type for the UVW and UVW2 (if defined) columns.
void | setFlagCategories (const Vector< String > &categories)
| Set the flag category labels to the supplied values (in the CATEGORY keyword of the FLAG_CATEGORY column).

## Private Member Functions

| MSConcat ()
void | checkShape (const IPosition &otherShape) const
void | checkCategories (const MSMainColumns &otherCols) const
Bool | checkEphIdInField (const MSFieldColumns &otherFldCol) const
Bool | copyPointing (const MSPointing &otherPoint, const Block< uInt > &newAntIndices)
Bool | copyPointingB (MSPointing &otherPoint, const Block< uInt > &newAntIndices)
Bool | copySysCal (const MSSysCal &otherSysCal, const Block< uInt > &newAndIndices)
Bool | copyWeather (const MSWeather &otherWeather, const Block< uInt > &newAndIndices)
Bool | copyGainCurve (const MeasurementSet &otherMS, const Block< uInt > &newAndIndices)
Bool | copyPhaseCal (const MeasurementSet &otherMS, const Block< uInt > &newAndIndices)
Bool | copyEOP (const MeasurementSet &otherMS)
Int | copyObservation (const MSObservation &otherObs, const Bool remRedunObsId=True)
Int | copyProcessor (const MSProcessor &otherObs, const Bool remRedunProcId=True)
Block< uInt > | copyAntennaAndFeed (const MSAntenna &otherAnt, const MSFeed &otherFeed)
Block< uInt > | copyState (const MSState &otherState)
Block< uInt > | copyField (const MeasurementSet &otherms)
Block< uInt > | copySpwAndPol (const MSSpectralWindow &otherSpw, const MSPolarization &otherPol, const MSDataDescription &otherDD)
Bool | copySource (const MeasurementSet &otherms)
Bool | updateSource ()
Bool | updateSource2 ()
Bool | sourceRowsEquivalent (const MSSourceColumns &sourceCol, const rownr_t &rowi, const rownr_t &rowj, const Bool dontTestDirection=False, const Bool dontTestTransAndRest=False)
Bool | obsRowsEquivalent (const MSObservationColumns &obsCol, const rownr_t &rowi, const rownr_t &rowj)
Bool | procRowsEquivalent (const MSProcessorColumns &procCol, const uInt &rowi, const uInt &rowj)
void | updateModelDataKeywords (MeasurementSet &ms)

## Static Private Member Functions

static IPosition | isFixedShape (const TableDesc &td)
static IPosition | getShape (const MSDataDescColumns &ddCols, const MSSpWindowColumns &spwCols, const MSPolarizationColumns &polCols, uInt whichShape)

## Private Attributes

MeasurementSet | itsMS
IPosition | itsFixedShape
Quantum< Double > | itsFreqTol
Quantum< Double > | itsDirTol
Float | itsWeightScale
Bool | itsRespectForFieldName
Vector< Bool > | itsChanReversed
std::map< Int, Int > | newSourceIndex_p
std::map< Int, Int > | newSourceIndex2_p
std::map< Int, Int > | newSPWIndex_p
std::map< Int, Int > | newObsIndexA_p
std::map< Int, Int > | newObsIndexB_p
std::map< Int, Int > | otherObsIdsWithCounterpart_p
std::map< Int, Int > | newProcIndexA_p
std::map< Int, Int > | newProcIndexB_p
std::map< Int, Int > | solSystObjects_p
Bool | doSource_p
Bool | doSource2_p
Bool | doSPW_p
Bool | doObsA_p
Bool | doObsB_p
Bool | doProcA_p
Bool | doProcB_p

## Additional Inherited Members

Protected Member Functions inherited from casacore::MSMainColumns
| MSMainColumns ()
void | attach (const MeasurementSet &ms)

## Detailed Description

A class with functions for concatenating MeasurementSets

### Intended use:

Public interface

### Review Status

Date Reviewed:
  yyyy/mm/dd

### Etymology

### Synopsis

### Example

### Motivation

Definition at line 74 of file MSConcat.h.

## Constructor & Destructor Documentation

## MSConcat() [1/2]

casacore::MSConcat::MSConcat | ( | MeasurementSet & | ms | ) |

## MSConcat() [2/2]

casacore::MSConcat::MSConcat | ( |  | ) |

private

## Member Function Documentation

## checkCategories()

void casacore::MSConcat::checkCategories | ( | const MSMainColumns & | otherCols | ) | const

private

## checkEphIdInField()

Bool casacore::MSConcat::checkEphIdInField | ( | const MSFieldColumns & | otherFldCol | ) | const

private

## checkShape()

void casacore::MSConcat::checkShape | ( | const IPosition & | otherShape | ) | const

private

## concatenate()

void casacore::MSConcat::concatenate | ( | const MeasurementSet & | otherMS,
|  | const uInt | handling = 0,
|  | const String & | destMSName = "" )

## copyAntennaAndFeed()

Block< uInt > casacore::MSConcat::copyAntennaAndFeed | ( | const MSAntenna & | otherAnt,
|  | const MSFeed & | otherFeed )

private

## copyEOP()

Bool casacore::MSConcat::copyEOP | ( | const MeasurementSet & | otherMS | ) |

private

## copyField()

Block< uInt > casacore::MSConcat::copyField | ( | const MeasurementSet & | otherms | ) |

private

## copyGainCurve()

Bool casacore::MSConcat::copyGainCurve | ( | const MeasurementSet & | otherMS,
|  | const Block< uInt > & | newAndIndices )

private

## copyObservation()

Int casacore::MSConcat::copyObservation | ( | const MSObservation & | otherObs,
|  | const Bool | remRedunObsId = True )

private

References casacore::True.

## copyPhaseCal()

Bool casacore::MSConcat::copyPhaseCal | ( | const MeasurementSet & | otherMS,
|  | const Block< uInt > & | newAndIndices )

private

## copyPointing()

Bool casacore::MSConcat::copyPointing | ( | const MSPointing & | otherPoint,
|  | const Block< uInt > & | newAntIndices )

private

## copyPointingB()

Bool casacore::MSConcat::copyPointingB | ( | MSPointing & | otherPoint,
|  | const Block< uInt > & | newAntIndices )

private

## copyProcessor()

Int casacore::MSConcat::copyProcessor | ( | const MSProcessor & | otherObs,
|  | const Bool | remRedunProcId = True )

private

References casacore::True.

## copySource()

Bool casacore::MSConcat::copySource | ( | const MeasurementSet & | otherms | ) |

private

## copySpwAndPol()

Block< uInt > casacore::MSConcat::copySpwAndPol | ( | const MSSpectralWindow & | otherSpw,
|  | const MSPolarization & | otherPol,
|  | const MSDataDescription & | otherDD )

private

## copyState()

Block< uInt > casacore::MSConcat::copyState | ( | const MSState & | otherState | ) |

private

## copySysCal()

Bool casacore::MSConcat::copySysCal | ( | const MSSysCal & | otherSysCal,
|  | const Block< uInt > & | newAndIndices )

private

## copyWeather()

Bool casacore::MSConcat::copyWeather | ( | const MSWeather & | otherWeather,
|  | const Block< uInt > & | newAndIndices )

private

## getShape()

IPosition casacore::MSConcat::getShape | ( | const MSDataDescColumns & | ddCols,
|  | const MSSpWindowColumns & | spwCols,
|  | const MSPolarizationColumns & | polCols,
|  | uInt | whichShape )

static private

## isFixedShape()

IPosition casacore::MSConcat::isFixedShape | ( | const TableDesc & | td | ) |

static private

## obsRowsEquivalent()

Bool casacore::MSConcat::obsRowsEquivalent | ( | const MSObservationColumns & | obsCol,
|  | const rownr_t & | rowi,
|  | const rownr_t & | rowj )

private

## procRowsEquivalent()

Bool casacore::MSConcat::procRowsEquivalent | ( | const MSProcessorColumns & | procCol,
|  | const uInt & | rowi,
|  | const uInt & | rowj )

private

## setRespectForFieldName()

void casacore::MSConcat::setRespectForFieldName | ( | const Bool | respectFieldName | ) |

## setTolerance()

void casacore::MSConcat::setTolerance | ( | Quantum< Double > & | freqTol,
|  | Quantum< Double > & | dirTol )

## setWeightScale()

void casacore::MSConcat::setWeightScale | ( | const Float | weightScale | ) |

## sourceRowsEquivalent()

Bool casacore::MSConcat::sourceRowsEquivalent | ( | const MSSourceColumns & | sourceCol,
|  | const rownr_t & | rowi,
|  | const rownr_t & | rowj,
|  | const Bool | dontTestDirection = False,
|  | const Bool | dontTestTransAndRest = False )

private

References casacore::False.

## updateModelDataKeywords()

void casacore::MSConcat::updateModelDataKeywords | ( | MeasurementSet & | ms | ) |

private

## updateSource()

Bool casacore::MSConcat::updateSource | ( |  | ) |

private

## updateSource2()

Bool casacore::MSConcat::updateSource2 | ( |  | ) |

private

## virtualconcat()

void casacore::MSConcat::virtualconcat | ( | MeasurementSet & | otherMS,
|  | const Bool | checkShapeAndCateg = True,
|  | const String & | obsidAndProcAndScanTableName = "" )

References casacore::True.

## Member Data Documentation

## doObsA_p

Bool casacore::MSConcat::doObsA_p

private

Definition at line 160 of file MSConcat.h.

## doObsB_p

Bool casacore::MSConcat::doObsB_p

private

Definition at line 161 of file MSConcat.h.

## doProcA_p

Bool casacore::MSConcat::doProcA_p

private

Definition at line 162 of file MSConcat.h.

## doProcB_p

Bool casacore::MSConcat::doProcB_p

private

Definition at line 163 of file MSConcat.h.

## doSource2_p

Bool casacore::MSConcat::doSource2_p

private

Definition at line 158 of file MSConcat.h.

## doSource_p

Bool casacore::MSConcat::doSource_p

private

Definition at line 157 of file MSConcat.h.

## doSPW_p

Bool casacore::MSConcat::doSPW_p

private

Definition at line 159 of file MSConcat.h.

## itsChanReversed

Vector<Bool> casacore::MSConcat::itsChanReversed

private

Definition at line 146 of file MSConcat.h.

## itsDirTol

Quantum<Double> casacore::MSConcat::itsDirTol

private

Definition at line 143 of file MSConcat.h.

## itsFixedShape

IPosition casacore::MSConcat::itsFixedShape

private

Definition at line 141 of file MSConcat.h.

## itsFreqTol

Quantum<Double> casacore::MSConcat::itsFreqTol

private

Definition at line 142 of file MSConcat.h.

## itsMS

MeasurementSet casacore::MSConcat::itsMS

private

Definition at line 140 of file MSConcat.h.

## itsRespectForFieldName

Bool casacore::MSConcat::itsRespectForFieldName

private

Definition at line 145 of file MSConcat.h.

## itsWeightScale

Float casacore::MSConcat::itsWeightScale

private

Definition at line 144 of file MSConcat.h.

## newObsIndexA_p

std::map<Int, Int> casacore::MSConcat::newObsIndexA_p

private

Definition at line 150 of file MSConcat.h.

## newObsIndexB_p

std::map<Int, Int> casacore::MSConcat::newObsIndexB_p

private

Definition at line 151 of file MSConcat.h.

## newProcIndexA_p

std::map<Int, Int> casacore::MSConcat::newProcIndexA_p

private

Definition at line 153 of file MSConcat.h.

## newProcIndexB_p

std::map<Int, Int> casacore::MSConcat::newProcIndexB_p

private

Definition at line 154 of file MSConcat.h.

## newSourceIndex2_p

std::map<Int, Int> casacore::MSConcat::newSourceIndex2_p

private

Definition at line 148 of file MSConcat.h.

## newSourceIndex_p

std::map<Int, Int> casacore::MSConcat::newSourceIndex_p

private

Definition at line 147 of file MSConcat.h.

## newSPWIndex_p

std::map<Int, Int> casacore::MSConcat::newSPWIndex_p

private

Definition at line 149 of file MSConcat.h.

## otherObsIdsWithCounterpart_p

std::map<Int, Int> casacore::MSConcat::otherObsIdsWithCounterpart_p

private

Definition at line 152 of file MSConcat.h.

## solSystObjects_p

std::map<Int, Int> casacore::MSConcat::solSystObjects_p

private

Definition at line 155 of file MSConcat.h.

The documentation for this class was generated from the following file:

- ms/MSOper/MSConcat.h